uses TPString,Graph,VGILow,VGIKeys,
     VGIApp,VgiDlg,VGIText,VgiBase,Objects,DOS,FileDlg;
const CursorSize=16;
      GrayFill:FillPatternType=($AA,$55,$AA,$55,$AA,$55,$AA,$55);
      InverseFill:FillPatternType=($F0,$F0,$F0,$F0,$0F,$0F,$0F,$0F);
var Main:PDialog;R:TRect;Cmd:Integer;
    Result:Boolean;
type
TMask = array [0..15] of word;
PCursorEditor = ^TCursorEditor;
TCursorEditor = object(TControl)
                 XStep,YStep:Integer;
                 Hot:TPoint;
                 ScreenMask,CursorMask:TMask;
                 Constructor Init(X1,Y1,X2,Y2:Integer);
                 Procedure Draw;virtual;
                 Procedure FillBox(X,Y:Integer);
                 Procedure Select;virtual;
                 Procedure Unselect;virtual;
                 Procedure SetData(var Rec);virtual;
                 Procedure GetData(var Rec);Virtual;
                 Function DataSize:word;virtual;
                 Function Handle(Code:Word):Integer;virtual;
                end;
PCursorDemo = ^TCursorDemo;
TCursorDemo = object(TControl)
                 Editor:PCursorEditor;
                 Constructor Init(X1,Y1,X2,Y2:Integer;AEditor:PCursorEditor);
                 Procedure Draw;virtual;
                 Function Handle(Code:Word):Integer;virtual;
              end;

Constructor TCursorEditor.Init(X1,Y1,X2,Y2:Integer);
var NewX2,NewY2:Integer;
begin
 NewX2:=(X2-X1)div CursorSize *CursorSize+X1;
 NewY2:=(Y2-Y1)div CursorSize *CursorSize+Y1;
 TControl.Init(X1,Y1,X2,Y2);
 FillChar(ScreenMask,SizeOf(ScreenMask),$FF);
 With Limits do
  begin
   XStep:=(B.X-A.X) div CursorSize;
   YStep:=(B.Y-A.Y) div CursorSize;
  end;
 Flags:=Flags or vfSelectable;
end;
Procedure TCursorEditor.Draw;
var X,Y,I:Integer;
begin
 Cursor^.Hide;
 SetColor(ForeColor);
 Limits.Draw;
 With Limits do
  begin
   X:=A.X;
   Y:=A.Y;
  end;
 For i:=1 to CursorSize-1 do
  With Limits do
  begin
   X:=X+XStep;
   Y:=Y+YStep;
   Line(A.X,Y,B.X-1,Y);
   Line(X,A.Y,X,B.Y-1);
  end;
  For X:=0 to 15 do
   For Y:=0 to 15 do
    FillBox(X,Y);
  Cursor^.Show;
end;
Procedure TCursorEditor.GetData(var Rec);
var C:TCursorShape absolute Rec;
begin
 System.move(CursorMask,C.CursorMask,SizeOf(TMask));
 System.move(ScreenMask,C.ScreenMask,SizeOf(TMask));
 C.HotY:=Hot.Y;
 C.HotX:=Hot.X;
end;
Procedure TCursorEditor.SetData(var Rec);
var C:TCursorShape absolute Rec;
begin
 System.move(C.CursorMask,CursorMask,SizeOf(TMask));
 System.move(C.ScreenMask,ScreenMask,SizeOf(TMask));
 Hot.Y:=C.HotY;
 Hot.X:=C.HotX;
 if Visible then Draw;
end;
Function TCursorEditor.DataSize:Word;
begin
 DataSize:=SizeOf(TCursorShape);
end;
const FileRec:Record
             Name:PathStr;
             Mode:word;
            end = (Name:'*.CRS';Mode:0);
Function GetFileName(Title:String;Flags:Word):Boolean;
var D:PDialog;C:PControl;X:Integer;
begin
 D:=MakeFileDialog(Title+' a file','~F~ile name:','*.CRS',Flags);
 X:=D^.Limits.B.Y-45;
 C:=(New(PRadioButtons,Init(340,X,430,X+32,NewSItem('~B~inary',
                                           NewSItem('~P~ascal',nil)))));
 D^.Insert(C);
 D^.Insert(New(PLabel,Init(340,X-15,430,X-1,'~M~ode',C)));
 D^.Insert(New(PBorder,Init(340,X,430,X+32)));
 D^.SetData (FileRec);
 X:=D^.Execute;
 if (X<>cmCancel)and(X<>cmClose) then
  begin
  D^.GetData(FileRec);
  GetFileName:=True;
  end
 else GetFileName:=False;
 Dispose(D,Done);
end;
Procedure TCursorEditor.FillBox(X,Y:Integer);
var Gray:Boolean;
begin
 Gray:=False;
 Cursor^.Hide;
 if ScreenMask[Y] and ($8000 shr X)<>0 then
  if CursorMask[Y] and ($8000 shr X)<>0 then
   SetFillPattern(InverseFill,BackColor)
  else
   begin
   SetFillPattern(GrayFill,BackColor);
   Gray:=True
   end
  else
   if CursorMask[Y] and ($8000 shr X)<>0 then
    SetFillStyle(SolidFill,BackColor)
  else
   SetFillStyle(SolidFill,ForeColor);
 Bar(X*XStep+1+Limits.A.X,Y*YStep+1+Limits.A.Y,(X+1)*XStep-2+Limits.A.X,
     (Y+1)*Ystep-2+Limits.A.Y);
 if (X=Hot.X)and(Y=Hot.Y) then
  begin
   SetColor($FF);
   SetLineStyle(SolidLn,0,ThickWidth);
   if not Gray then SetWriteMode(XorPut);
   Line(X*XStep+1+Limits.A.X,Y*YStep+1+Limits.A.Y,(X+1)*XStep-2+Limits.A.X,
     (Y+1)*Ystep-2+Limits.A.Y);
   Line(X*XStep+1+Limits.A.X,(Y+1)*Ystep-2+Limits.A.Y,(X+1)*XStep-2+Limits.A.X,
     Y*YStep+1+Limits.A.Y);
   SetWriteMode(CopyPut);
  end;
 Cursor^.Show;
end;
Procedure TCursorEditor.Select;
begin
 EnableKeyMove;
end;
Procedure TCursorEditor.Unselect;
begin
 DisableKeyMove;
end;
Function TCursorEditor.Handle(Code:Word):Integer;
var X,Y:Integer;Tmp:TPoint;
Procedure Toggle(var Mask:TMask);
begin
 Mask[Y]:=Mask[y] xor ($8000 shr X);
 FillBox(X,Y);
end;
begin
   Handle:=0;
   X:=(Event.X-Limits.A.X)div XStep;
   Y:=(Event.Y-Limits.A.Y) div XStep;
 if (Code and $FF00) = kbMousePressed then
  begin
   Case Lo(Code) of
   kbMouseLeft:Toggle(CursorMask);
   kbMouseRight:Toggle(ScreenMask);
   kbMouseLeft+kbMouseRight:begin
                Toggle(ScreenMask);
                Toggle(CursorMask);
               end;
   end;
  Handle:=-10;
 end ELSE
 Case Code of
 kbF1:Handle :=6;{Help}
 kbF2:Handle :=5;{Save}
 kbF3:Handle :=4;{Load}
 kbF7:begin
       Tmp:=Hot;
       Hot.X:=X;
       Hot.Y:=Y;
       FillBox(X,Y);
       FillBox(Tmp.X,Tmp.Y);
       Handle:=cmEventProcessed;
      end;
 kbBackSpace:begin
                Toggle(ScreenMask);
                Toggle(CursorMask);
                Handle:=-10;
               end;
 else
  Handle:=0;
  exit;
 end;
end;
Constructor TCursorDemo.Init(X1,Y1,X2,Y2:Integer;AEditor:PCursorEditor);
begin
 TControl.Init(X1,Y1,X2,Y2);
 Editor:=AEditor;
end;
Procedure TCursorDemo.Draw;
var M:TMask;I:Integer;D:PImage;
begin
 SetFillPattern(GrayFill,BackColor);
 Limits.Fill;
 SetColor(ForeColor);
 SetLineStyle(SolidLn,0,NormWidth);
 Limits.Draw;
 For I:=0 to 15 do
  M[i]:=Swap(Editor^.ScreenMask[i]);
 D:=Bits2Image(Pred(CursorSize),Pred(CursorSize),M,$FF,0);
 PutImage(Limits.A.X+1,Limits.A.Y+1,D^,AndPut);
 DisposeImage(D);
 For I:=0 to 15 do
  M[i]:=Swap(Editor^.CursorMask[i]);
 D:=Bits2Image(Pred(CursorSize),Pred(CursorSize),M,$FF,0);
 PutImage(Limits.A.X+1,Limits.A.Y+1,D^,XorPut);
 DisposeImage(D);
end;
Function TCursorDemo.Handle(Code:Word):Integer;
begin
 if Code=10 then
  begin
   Draw;
    Handle:=cmEventProcessed;
  end else Handle:=0;
end;
var E:PCursorEditor;
    Crs:TCursorShape;
  Function LoadShape(FileName : string) : boolean;
    var str  : string;
        fl   : text;
    { ======================== GetHotPoint ======================== }
    Procedure GetHotPoint;
    begin
      str:=Trim(str);
      str:=Copy(str,7,length(str)-7);
      Delete(str,3,5);
      if (not Str2Int(ExtractWord(1,str,[';']),Crs.HotX)) or
         (not Str2Int(ExtractWord(2,str,[';']),Crs.HotY)) then
      begin
        LoadShape:=false;
        exit;
      end;
    end;
    { ========================== GetMask ========================== }
    Procedure GetMask(var ThisMask : TMask);
      var i : integer;
    begin
      str:=Trim(str);               { १ ஡ }
      str:=Copy(str,13,length(str)-14);

      if WordCount(str,[',',')']) <> 16 then
      begin
        LoadShape:=false;
        exit;
      end;

      for i:=0 to 15 do
        if not Str2Word(ExtractWord(i+1,str,[',',')']),ThisMask[i]) then
        begin
          LoadShape:=false;
          exit;
        end;
    end;

  begin
    assign(fl,FileName);
    reset(fl);

    readln(fl);
    readln(fl,str);
    GetHotPoint;

    readln(fl,str);
    GetMask(TMask(Crs.ScreenMask));
    readln(fl,str);
    GetMask(TMask(Crs.CursorMask));
    LoadShape:=true;
    Close(Fl);
  end;
Function LoadBin(FileName:String):Boolean;
var F:File of TCursorShape;
begin
 Assign(F,FileName);
 Reset(F);
 Read(F,Crs);
 LoadBin:=IOREsult=0;
 Close(F);
end;
Procedure SaveBin(FileName:String);
var F:File of TCursorShape;
begin
 Assign(F,FileName);
 Rewrite(F);
 Write(F,Crs);
 Close(F);
end;
Procedure SaveShape(FileName:String);
    var   fpas : text;
          i    : integer;
  begin
      assign(fpas,FileName);
      rewrite(fpas);
      writeln(fpas,'Const crs:TCursorShape=');
      writeln(fpas,'          (HotX:',Crs.HotX,';HotY:',Crs.HotY,';');
      write(fpas,'          ScreenMask:(');
        for i:=0 to 15 do
        begin
          write(fpas,'$'+HexW(Crs.ScreenMask[i]));
          if i<15 then
            write(fpas,',')
          else
            writeln(fpas,');');
        end;
      write(fpas,'          CursorMask:(');
        for i:=0 to 15 do
        begin
          write(fpas,'$',HexW(Crs.CursorMask[i]));
          if i<15 then
            write(fpas,',')
          else
            writeln(fpas,'));');
        end;
      Close(fpas);
    end;
 begin
  BgiPath:='E:\BP\BGI';
  InitVGI;
  Main:=New(PDialog,Init(0,0,320,200,'Cursor Editor'));
  E:=New(PCursorEditor,Init(10,20,170,180));
  Main^.Insert(E);
  Main^.Insert(New(PCursorDemo,Init(175,20,195,40,E)));
  R.Assign(220,20,300,40);
  With R do
  Main^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,'~T~est',1,True)));
  R.Move(0,25);
  With R do
  Main^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,'~R~estore',2,False)));
  R.Move(0,25);
   With R do
  Main^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,'~C~lear',3,False)));
  R.Move(0,25);
  With R do
  Main^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,'~L~oad',4,False)));
  R.Move(0,25);
  With R do
  Main^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,'~S~ave',5,False)));
  R.Move(0,25);
  With R do
  Main^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,'~H~elp',6,False)));
  R.Move(0,25);
  With R do
  Main^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,'~Q~uit',cmClose,False)));
  SetFillStyle(SolidFill,11);
  Bar(0 ,0,MaxGraphX,MaxGraphY);
  Main^.Selectnext;
  Main^.Move((Succ(MaxGraphX)-320) div 2,(Succ(MaxGraphY)-200)div 2);
  Cursor^.Show;
  Main^.Draw;
  Repeat
  Cmd:=Main^.Execute;
  Case Cmd of
  1:{Test}
    begin
     Main^.GetData(Crs);
     Cursor^.SetShape(Crs);
    end;
  2:Cursor^.SetShape(DefaultShape);
  3:begin
     Crs.hotX:=0;
     Crs.HotY:=0;
     FillChar(Crs.ScreenMask,$FF,SizeOf(TMask));
     FillChar(Crs.CursorMask,0,SizeOf(TMask));
     Main^.SetData(Crs);
    end;
   4:
      if GetFileName('Load',fdOldFile+fdOpenButton) then
       begin
        if FileRec.Mode = 0 then Result:=LoadBin(FileRec.Name)
                            else Result:=LoadShape(FileRec.Name);
        if Result then Main^.SetData(Crs);
       end;
   5:if GetFileName('Save',fdNewFile+fdOkButton+fdReplaceButton) then
    begin
        Main^.GetData(Crs);
        if FileRec.Mode = 0 then SaveBin(FileRec.Name)
                            else SaveShape(FileRec.Name);
       end;


   end;
  Until Cmd=cmClose;
  Dispose(Main,Done);
  Delay(500);
end.
