{****************************************************************************}
{*                                                                          *}
{*                          Vitus Graphic Interface                         *}
{*                                Version 2.5                               *}
{*           Easy, event driven, object oriented graphic interface          *}
{*                       for Turbo Pascal 5.5 or higher                     *}
{*                 Copyright (c) by Vitus B.Wagner, 1991-1993               *}
{*                                                                          *}
{*                              VGIKEYS.PAS                           *}
{*   । ᪨ ⠭      ᮡ⨩   *}
{****************************************************************************}
Unit VGIKeys;
Interface
const
  { }
  kbEsc       = $011B;  kbAltSpace  = $0200;  kbCtrlIns   = $9200;
  kbShiftIns  = $0500;  kbCtrlDel   = $9300;  kbShiftDel  = $0700;
  kbBack      = $0E08;  kbCtrlBack  = $0E7F;  kbShiftTab  = $0F00;
  kbTab       = $0F09;  kbAltQ      = $1000;  kbAltW      = $1100;
  kbAltE      = $1200;  kbAltR      = $1300;  kbAltT      = $1400;
  kbAltY      = $1500;  kbAltU      = $1600;  kbAltI      = $1700;
  kbAltO      = $1800;  kbAltP      = $1900;  kbCtrlEnter = $1C0A;
  kbEnter     = $1C0D;  kbAltA      = $1E00;  kbAltS      = $1F00;
  kbAltD      = $2000;  kbAltF      = $2100;  kbAltG      = $2200;
  kbAltH      = $2300;  kbAltJ      = $2400;  kbAltK      = $2500;
  kbAltL      = $2600;  kbAltZ      = $2C00;  kbAltX      = $2D00;
  kbAltC      = $2E00;  kbAltV      = $2F00;  kbAltB      = $3000;
  kbAltN      = $3100;  kbAltM      = $3200;  kbF1        = $3B00;
  kbF2        = $3C00;  kbF3        = $3D00;  kbF4        = $3E00;
  kbF5        = $3F00;  kbF6        = $4000;  kbF7        = $4100;
  kbF8        = $4200;  kbF9        = $4300;  kbF10       = $4400;
  kbHome      = $4700;  kbUp        = $4800;  kbPgUp      = $4900;
  kbGrayMinus = $4A2D;  kbLeft      = $4B00;  kbRight     = $4D00;
  kbGrayPlus  = $4E2B;  kbEnd       = $4F00;  kbDown      = $5000;
  kbPgDn      = $5100;  kbIns       = $5200;  kbDel       = $5300;
  kbShiftF1   = $5400;  kbShiftF2   = $5500;  kbShiftF3   = $5600;
  kbShiftF4   = $5700;  kbShiftF5   = $5800;  kbShiftF6   = $5900;
  kbShiftF7   = $5A00;  kbShiftF8   = $5B00;  kbShiftF9   = $5C00;
  kbShiftF10  = $5D00;  kbCtrlF1    = $5E00;  kbCtrlF2    = $5F00;
  kbCtrlF3    = $6000;  kbCtrlF4    = $6100;  kbCtrlF5    = $6200;
  kbCtrlF6    = $6300;  kbCtrlF7    = $6400;  kbCtrlF8    = $6500;
  kbCtrlF9    = $6600;  kbCtrlF10   = $6700;  kbAltF1     = $6800;
  kbAltF2     = $6900;  kbAltF3     = $6A00;  kbAltF4     = $6B00;
  kbAltF5     = $6C00;  kbAltF6     = $6D00;  kbAltF7     = $6E00;
  kbAltF8     = $6F00;  kbAltF9     = $7000;  kbAltF10    = $7100;
  kbCtrlPrtSc = $7200;  kbCtrlLeft  = $7300;  kbCtrlRight = $7400;
  kbCtrlEnd   = $7500;  kbCtrlPgDn  = $7600;  kbCtrlHome  = $7700;
  kbAlt1      = $7800;  kbAlt2      = $7900;  kbAlt3      = $7A00;
  kbAlt4      = $7B00;  kbAlt5      = $7C00;  kbAlt6      = $7D00;
  kbAlt7      = $7E00;  kbAlt8      = $7F00;  kbAlt9      = $8000;
  kbAlt0      = $8100;  kbAltMinus  = $8200;  kbAltEqual  = $8300;
  kbCtrlPgUp  = $8400;  kbNoKey     = $0000;  kbSpace     = $3920;
  kbBackSpace = $0E08;  kbCtrlBreak = $FFFF;
  kbGrayEnter = $E00D;  kbGraySlash = $E02F;  kbGrayStar  = $372A;
  kbF11 = $8500; kbShiftF11 = $8700; kbCtrlF11 = $8900; kbAltF11 = $8B00;
  kbF12 = $8600; kbShiftF12 = $8800; kbCtrlF12 = $8A00; kbAltF12 = $8C00;
  kbCtrlUp =$8D00;kbCtrlDown=$9100;
  kbAltUp = $9800; kbAltDown = $A000; kbAltRight = $9D00; kbAltLeft = $9B00;
  kbAltIns = $A200; kbAltDel = $A300; kbAltHome =$9700; kbAltEnd = $9F00;
  kbAltPgUp = $9900; kbAltPgDn=$A1;
 kbAltBackSpace=$0EF0;
{ ᮡ⨩  }         { ᮡ⨩  ⠩}
  kbMouseMoved = $FF00;         kbCursorMoved = $F700;
  kbMousePressed = $FE00;       kbButtonPressed = $F600;
  kbMouseReleased = $FD00;      kbButtonReleased = $F500;
  kbMouseLeft = 1;
  kbMouseRight = 2;
  kbMouseCenter = 4;
{ }
  kbfRightShift=1;
  kbfLeftShift =2;
  kbfBothShift = kbfRightShift+kbfLeftShift;
  kbfCtrl      =4;
  kbfAlt       =8;
  kbfScrollLock=$10;
  kbfNumLock   =$20;
  kbfCapsLock  =$40;
  kbfInsert    =$80;
implementation

end.
