unit VGIDlg;
interface
uses graph,VGILow,vgiKeys,VGIBase,VGIText,Objects;
Type PFreeRec = ^TFreeRec;
     TFreeRec = record
                 Next:PFreeRec;
                 Size:Pointer;
                end;
Const{TGraphicText Flags}
  tfTop = $800;
  tfVCenter = $400;
  tfHCenter = $1000;
  tfRight = $2000;
  tfFillVert = $4000;
  tfFillHoriz = $8000;
  tfFillBoth = tfFillVert+tfFillHoriz;
  GrayFill:FillPatternType=($55,$AA,$55,$AA,$55,$AA,$55,$AA);
 {All other negative commands are transferred to all controls as keycode with
 charcode = abs(command) and Scancode = $80}
{All Positive commands cause exit from TDialog.Execute and are returned by it}
{Reserved commands}
cmIdle = $8000;
cmButtonSelected = 259;
cmDefaultChanged = 260;
cmScrolling = 261;
cmClose=262;
cmRedraw=257;
cmEventProcessed = -32768; {Returned by control if Event successifully handled
                           {but no additional action is needed}

Type
TSet     = set of 0..255;
PControl = ^TControl;
PDialog = ^TDialog;
TDialog = object (TVisibleObject)
            Title:PString;
            First,Current:PControl;
            CloseButton:TGrRect;
            CommandPool:Integer;
            SavePtr:Pointer;
            Visible:Integer;
            ButtonSelected:Boolean;{Used by default button for know must it}
                                   {handle Enter or not}
            Constructor Init(X1,Y1,X2,Y2:integer;ATitle:String);
            Constructor Load(var S:TStream);
            Procedure Drag(Stop:Word);
            Procedure Store(var S:TStream);
            Procedure Move(DX,DY:Integer);virtual;
            Destructor Done;virtual;
            Procedure Draw;virtual;
            Procedure Hide;virtual;
            function Next(P:PControl):PControl;
            function Prev(P:PControl):PControl;
            Function Last:PControl;
            Function Insert(P:PControl):PDialog;
            Function Execute:Integer;
            Procedure Center;
            Procedure PutCommand(Command:Integer);
            function Handle(Code:Word):Integer;Virtual;
            Procedure SetData(var Rec);virtual;
            Procedure GetData(var Rec);virtual;
            Function DataSize:Word;virtual;
            Procedure SelectControl(AControl:PControl);
            Function SelectNext:PDialog;
            Function SelectPrev:PDialog;
            Procedure GetControlPtr(Var S:TStream;var P:PControl);virtual;
            Procedure PutControlPtr(Var S:TStream;P:PControl);virtual;
            Function ViewAt(Index:Integer):PControl;
            Function IndexOf(Item:PControl):Integer;
            Function  SetFlags(AFLags:Word):PDialog;
            Function  ClearFlags(AFLags:Word):PDialog;
           end;
TControl = object (TVisibleObject)
            NextControl:PControl;
            Owner:PDialog;
            Constructor Init(X1,Y1,X2,y2:Integer);
            Procedure Draw;virtual;
            Procedure Select;virtual;
            Procedure Unselect;virtual;
            Function Visible:Boolean;
            Procedure Move(DX,DY:Integer);virtual;
            function Handle(Code:Word):Integer;Virtual;
            Procedure SetData(var Rec);virtual;
            Procedure GetData(var Rec);virtual;
            Function DataSize:Word;virtual;
            Procedure GetControlPtr(Var S:TStream;var P:PControl);virtual;
            Procedure PutControlPtr(Var S:TStream;P:PControl);virtual;
           end;

PButton = ^TButton;
TButton = object (TControl)
           Default:boolean;
           Text:PString;
           Cmd:Integer;
           constructor Init(X1,Y1,X2,Y2:integer;AText:STring;ACommand:Integer;ADefault:Boolean);
            Constructor Load(var S:TStream);
            Procedure Store(var S:TStream);
           Procedure Select;virtual;
           Procedure Unselect;virtual;
           Procedure MakeDefault;
           Procedure Draw;virtual;
           Procedure Press;virtual;
            function Handle(Code:Word):Integer;Virtual;
            Destructor Done;virtual;
          end;
PGraphicText = ^TGraphicText;
TGraphicText = object (TControl)
               Text:PString;
               Font:Byte;
               Constructor Init(X1,y1,x2,y2:Integer;Atext:String;AFont:Byte;
                                Aflags:Word);
               Constructor Load(var S:TStream);
               Procedure Store(var S:TStream);
               Procedure Draw;virtual;
               Destructor Done;virtual;
              end;
PPicture = ^TPicture;
TPicture = object (TControl)
            BitMap:PString;
            Deallocate:boolean;
            Constructor Init (X1,y1,X2,y2:Integer;ABitMap:Pointer;
             ADeallocate:Boolean);
            Constructor Load(var S:TStream);
            Procedure Store(var S:TStream);
            Procedure Draw;virtual;
            Function BitSize:Word;
            Destructor Done;virtual;
           end;
Function Rot4(X:Word):Word;Inline
 ($58              {POP AX}
 /$B1/$04          {MOV CL,4}
 /$D3/$c8          {ROR AX,CL});
type
PPictogram = ^TPictogram;
TPictogram = object(TPicture)
              Cmd:Integer;
              PrevTime:Word;
              Constructor Init(X1,y1,X2,y2:Integer;ABitMap:Pointer;
             ADeallocate:Boolean;Command:Integer);
             function Handle(Code:Word):Integer;Virtual;
             Constructor Load(var S:TStream);
             Procedure Store(var S:TStream);
             Procedure Select;virtual;
             Procedure Unselect;virtual;
             end;
PTextLine = ^TTextLine;
TTextLine = object(TControl)
             Function GetText:String;virtual;
             Procedure Draw;virtual;
            end;
PStaticText = ^TStaticText;
TStaticText = Object(TTextLine)
               Text:PString;
               Constructor Load(var S:TStream);
               Procedure Store(var S:TStream);
               Constructor Init(X1,Y1,X2,Y2:Integer;Atext:String);
               Destructor Done;virtual;
               Function GetTExt:String;virtual;
           end;
PLabel = ^TLabel;
TLabel = object(TStaticText)
          Link:PControl;
          Scan:Byte;
          Constructor Init(X1,Y1,X2,Y2:Integer;Atext:String;ALink:PControl);
          Constructor Load(var S:TStream);
          Procedure Store(var S:TStream);
          Function Handle(Code:Word):Integer;virtual;
         end;
PViewLine = ^TViewLine;
TViewLine = object(TTextLine)
              Text:PString;
              MaxLen:Integer;
              Function GetTExt:String;virtual;
              Constructor Init(X1,Y1,X2,Y2,AMaxLen:Integer);
              Constructor Load(var S:TStream);
              Procedure Store(var S:TStream);
              Procedure SetData(var Rec);virtual;
              Procedure GetData(var Rec);virtual;
              Function DataSize:Word;virtual;
              Destructor Done;virtual;
            end;
PBorder = ^TBorder;
TBorder = object(TControl)
           Procedure Draw;virtual;
          end;

PInputLine = ^TInputLine;
TInputLine = object (TControl)
              Data:PString;
              CurPos,StartPos:Integer;
              MaxLen,DispLen:Byte;
              ClearEntry:Boolean;
              Constructor Load(var S:TStream);
              Procedure Store(var S:TStream);
              Constructor Init(X1,Y1,X2,Y2,AMaxLen:Integer);
              Procedure SetData(var Rec);Virtual;
              Procedure GetData(var Rec);Virtual;
              Function DataSize:Word;virtual;
              Procedure  Select;virtual;
              Procedure Unselect;virtual;
              Procedure Draw;Virtual;
              Procedure  DrawCursor(On:Boolean);
              Function Handle(Code:Word):Integer;virtual;
              Destructor Done;virtual;
             end;
PScrollBar = ^TScrollBar;
TScrollBar = object(TControl)
              Size:Integer;
              Pos:Integer;
              ArStep,PgStep:Integer;
              Changed:Boolean;
              Vert:Boolean;
              Link:PControl;
              PrevTime:LongInt;
              Constructor Init(X1,y1,x2,y2:Integer;Vertical:Boolean);
              Constructor Load(var S:TStream);
              Procedure Store(var S:TStream);
              Procedure Draw;virtual;
              Procedure Unselect;virtual;
              Procedure SetParams(ASize,APos,AArStep,APgStep:Integer);
              Function GetPos:Integer;
              Function Handle(Code:Word):Integer;virtual;
             end;
TListBoxRec = Record
               List:PCollection;
               Focused:Integer;
              end;
TMultyBoxRec = record
                List:PCollection;
                Focused:Integer;
                Selected:TSet;
               end;

PListBox = ^TListBox;
TListBox = object(TControl)
            List:PCollection;
            Focused:Integer;
            TopItem:Integer;
            Range:Integer;
            VisItems:Integer;
            ScrollBar:PScrollBar;
            Constructor Init(X1,Y1,X2,Y2:Integer;AScrollBar:PScrollBar);
              Constructor Load(var S:TStream);
              Procedure Store(var S:TStream);
            Procedure Draw;Virtual;
            Procedure DrawItem(Item:Integer);virtual;
            Function GetText(Item:Integer):String;virtual;
            Function IsSelected(Item:Integer):Boolean;virtual;
            Procedure SelectItem(Item:Integer);virtual;
            Procedure SetData(Var Rec);virtual;
            Procedure GetData(var Rec);virtual;
            Procedure NewList(AList:PCollection);virtual;
            Procedure ScrollTo(Item:Integer);virtual;
            Procedure Select;virtual;
            Procedure Unselect;Virtual;
            Function DataSize:word;virtual;
            Function Handle(Code:Word):Integer;virtual;
           end;
PMultyBox = ^TMultyBox;
TMultyBox = object(TListBox)
            Selected:TSet;
             Function IsSelected(Item:Integer):Boolean;virtual;
             Procedure SelectItem(Item:Integer);virtual;
             Procedure SetData(Var Rec);virtual;
             Procedure GetData(var Rec);virtual;
            end;
PStringNode = ^TStringNode;
TStringNode = Record
                Next:PStringNode;
                S:String;
              end;
PCluster = ^TCluster;
TCluster = object(TControl)
             Value:Word;
             Sel:Word;
             Strings:PStringNode;
             Constructor Init(X1,y1,x2,y2:Integer;Astrings:PStringNode);
             Constructor Load(var S:TStream);
             Procedure Store(var S:TStream);
             Procedure DrawBox(boxNo:Integer);Virtual;
             Procedure Mark(BoxNo:Integer);virtual;
             Procedure Draw;virtual;
             Procedure SetData(var Rec);virtual;
             Procedure GetData(var Rec);virtual;
             Function DataSize:Word;virtual;
             Procedure Select;virtual;
             Procedure UnSelect;virtual;
             Function Handle(Code:Word):Integer;virtual;
             Destructor Done;virtual;
          end;
PCheckBox = ^TCheckBox;
TCheckBox = object(TCluster)
             Procedure DrawBox(boxNo:Integer);Virtual;
             Procedure Mark(BoxNo:Integer);virtual;
            end;

PRadioButtons = ^TRadioButtons;
TRadioButtons = object(TCluster)
             Procedure DrawBox(boxNo:Integer);Virtual;
             Procedure Mark(BoxNo:Integer);virtual;
                end;

{$IFNDEF Ver55}
Const RDialog :TStreamRec = (ObjType:1;
                             VmtLink:ofs(TypeOf(TDialog)^);
                             Load:@TDialog.Load;
                             Store:@TDialog.Store);
          RButton :TStreamRec = (ObjType:2;
                             VmtLink:ofs(TypeOf(TButton)^);
                             Load:@TButton.Load;
                                                         Store:@TButton.Store);
          RStaticText :TStreamRec = (ObjType:3;
                             VmtLink:ofs(TypeOf(TStaticText)^);
                             Load:@TStaticText.Load;
                             Store:@TStaticText.Store);
          RPicture :TStreamRec = (ObjType:4;
                             VmtLink:ofs(TypeOf(TPicture)^);
                             Load:@TPicture.Load;
                             Store:@TPicture.Store);
          RInputLine :TStreamRec = (ObjType:5;
                             VmtLink:ofs(TypeOf(TInputLine)^);
                             Load:@TInputLine.Load;
                             Store:@TInputLine.Store);
          RScrollBar :TStreamRec = (ObjType:6;
                             VmtLink:ofs(TypeOf(TScrollBar)^);
                             Load:@TScrollBar.Load;
                             Store:@TScrollBar.Store);
          RListBox :TStreamRec = (ObjType:7;
                             VmtLink:ofs(TypeOf(TListBox)^);
                             Load:@TListBox.Load;
                             Store:@TListBox.Store);
          RMultyBox :TStreamRec = (ObjType:8;
                                                         VmtLink:ofs(TypeOf(TMultyBox)^);
                                                         Load:@TMultyBox.Load;
                                                         Store:@TMultyBox.Store);
          RCheckBox :TStreamRec = (ObjType:9;
                             VmtLink:ofs(TypeOf(TCheckBox)^);
                             Load:@TCheckBox.Load;
                             Store:@TCheckBox.Store);
          RRadioButtons :TStreamRec = (ObjType:10;
                             VmtLink:ofs(TypeOf(TRadioButtons)^);
                             Load:@TRadioButtons.Load;
                             Store:@TRadioButtons.Store);
          RPictoGram :TStreamRec = (ObjType:11;
                             VmtLink:ofs(TypeOf(TPictogram)^);
                             Load:@TPictogram.Load;
                             Store:@TPictogram.Store);
          RBorder :TStreamRec = (ObjType:12;
                             VmtLink:ofs(TypeOf(TBorder)^);
                             Load:@TBorder.Load;
                             Store:@TBorder.Store);
          RLabel :TStreamRec = (ObjType:13;
                             VmtLink:ofs(TypeOf(TLabel)^);
                             Load:@TLabel.Load;
                             Store:@TLabel.Store);
          RViewLine :TStreamRec = (ObjType:14;
                             VmtLink:ofs(TypeOf(TViewLine)^);
                             Load:@TViewLine.Load;
                                                         Store:@TViewLine.Store);
          RGraphicText:TStreamRec = (ObjType:15;
                                                         VmtLink:ofs(TypeOf(TGraphicText)^);
                                                         Load:@TGraphicText.Load;
                                                         Store:@TGraphicText.Store);

{$ELSE}
Const RDialog :TStreamRec = (ObjType:100);
      RButton :TStreamRec = (ObjType:101);
      RStaticText :TStreamRec = (ObjType:102);
      RPicture :TStreamRec = (ObjType:103);
      RInputLine :TStreamRec = (ObjType:104);
      RScrollBar :TStreamRec = (ObjType:105);
      RListBox :TStreamRec = (ObjType:106);
      RCheckBox :TStreamRec = (ObjType:107);
      RRadioButtons :TStreamRec = (ObjType:108);
      RPictoGram :TStreamRec = (ObjType:110);
      RBorder :TStreamRec = (ObjType:111);
      RLabel :TStreamRec = (ObjType:112);
      RViewLine :TStreamRec = (ObjType:113);
{$ENDIF}

      Procedure RegisterDlg;
Function NewSItem(Text:String;Next:PStringNode):PStringNode;
implementation
{********************** TDialog *******************************************}
var ShiftStatus:Byte absolute $40:$17;
Constructor TDialog.Init(X1,Y1,X2,Y2:integer;ATitle:String);
begin
 TObject.Init;
 Limits.Assign(X1,Y1,X2,Y2);
 Flags:=vfMoveable;
 Title:=NewStr(ATitle);
 With limits do
 CloseButton.Assign(A.X+1,A.Y+1,A.X+12,A.Y+FontSize);
end;
{樠   ATLRC, ॡ騩 䨪}
Type PPointer = ^Pointer;
var LinkList:PCollection;
    LoadingDialog:PDialog;
Constructor TDialog.Load(var S:TStream);
var P:PControl;
{$F+}
Procedure SetControlPtr(Link:PPointer);
begin
 Link^:=LoadingDialog^.ViewAT(LongInt(Link^));
end;
{$F-}
begin
 {Load TDialog fields}
 TVisibleObject.Load(S);
 Title:=S.ReadStr;
 With limits do
 CloseButton.Assign(A.X+1,A.Y+1,A.X+12,A.Y+FontSize);
 {Load controls}
 New(LinkList,Init(8,4));
 Repeat
  P:=PControl(S.Get);
  Insert(P)
 Until P=nil;
 LoadingDialog:=@Self;
 {Set up intercontrol pointers}
 LinkList^.ForEach(@SetControlPtr);
 LinkList^.DeleteAll;
 Dispose(LinkList,Done);
 {SetUP Current}
 GetControlPtr(S,Current);
end;
Procedure TDialog.Store(var S:TStream);
Label 1;
var P:PControl;
begin
 TVisibleObject.Store(S);
 S.WriteStr(Title);
 P:=First;
 Repeat
  S.Put(P);
  if P=nil then goto 1;
  P:=P^.NextControl;
 Until false;
 1:PutControlPtr(S,Current);
end;
Procedure TDialog.GetControlPtr(var S:TStream;Var P:PControl);
var W:Word;
begin
 S.Read(W,2);
 P:=ViewAt(W);
end;
Procedure TDialog.PutControlPtr(var S:TStream;P:PControl);
var W:Word;
begin
 W:=IndexOf(P);
 S.Write(W,2);
end;
Function TDialog.SetFlags(AFlags:Word):PDialog;
begin
 Flags:=Flags or AFlags;
 SetFlags:=@Self;
end;
Function TDialog.ClearFlags(AFlags:Word):PDialog;
begin
 Flags:=Flags and not AFlags;
 ClearFlags:=@Self;
end;
Procedure TDialog.Drag(Stop:Word);
var R:TGrRect;
    Cmd:Word;
Procedure MoveRect(Dx,DY:Integer);
begin
 R.Draw;
 R.Move(Dx,DY);
 Cursor^.Move(R.A.X,R.A.Y);
 R.Draw;
end;
Procedure Drawrect;
begin
 R.Draw;
end;
begin
  if Flags and vfMoveable=0 then exit;
  DisableKeyMove;
  Cursor^.Hide;
  SetWriteMode(XorPut);
  SetLineStyle(SolidLn,0,NormWidth);
  SetColor(GetMaxColor);
  R.Copy(Limits);
  R.Grow(-1,-1);
  Cursor^.Move(R.A.X,R.A.Y);
  DrawRect;
  Repeat
   Cmd:=GetEvent;
   if Cmd<>0 then
   begin
   case Cmd of
   kbMouseMoved..kbMouseMoved+$FF:
    begin
     If Event.X+R.B.X-R.A.X>=Pred(MaxGraphX) then
      Event.X:=MaxGraphX-Succ(R.B.X)+Pred(R.A.X);
     IF Longint(Event)<>LongInt(R.A) then
      MoveRect(Event.X-R.A.X,Event.Y-R.A.Y);
    end;
 kbEsc:     begin
      DrawRect;
      SetWriteMode(CopyPut);
      EnableKeyMove;
      Cursor^.Show;
      exit;
    end;
  kbLeft:if R.A.X>=5 then MoveRect(-5,0);
  kbRight:begin
           if R.B.X<MaxGraphX-6 then
           MoveRect(5,0);
          end;
  kbUp:if R.A.Y>=5 then MoveRect(0,-5);
  kbDown:if R.A.Y<MaxGraphY-15 then MoveRect(0,5);
  end;
 end;
  Until cmd=Stop;
      DrawRect;
      SetWriteMode(CopyPut);
      Hide;
      Move(R.A.X-Limits.A.X,R.A.Y-Limits.A.Y);
      Draw;
      EnableKeyMove;
      Cursor^.Show;
end;
Procedure TDialog.Move(DX,DY:Integer);
var Q:PControl;
    V:Boolean;
begin
 Hide;
 Limits.Move(DX,DY);
 CloseButton.Move(DX,DY);
 Q:=First;
 While Q<>nil do
  begin
   Q^.Move(DX,DY);
   Q:=Q^.NextControl;
  end;
 Draw;
end;
Function TDialog.ViewAt(Index:Integer):PControl;
var P:PControl;I:Integer;
begin
 P:=First;
 For i:=1 to Index do P:=P^.NextControl;
 ViewAt:=P;
end;
Function TDialog.IndexOf(Item:PControl):Integer;
var I:Integer;P:PControl;
begin
 i:=0;
 P:=First;
 While P<>Item do
  begin
   P:=P^.NextControl;
   inc(i);
  end;
 IndexOf:=I;
end;

Procedure TDialog.Draw;
var P:PControl;T:TPoint;
begin
  inc(Visible);
if Visible<=0 then exit;
Flags:=flags or vfVisible;
Cursor^.Hide;
 if Visible=1 then
   SavePtr:=Limits.SaveScreen;
  SetLineStyle(SolidLn,0,ThickWidth);
  SetColor(ForeColor);
   With Limits do
    begin
     RectAngle(A.X+1,A.Y+1,B.X-2,B.Y-2);
     SetFillStyle(SolidFill,BackColor);
     Bar(A.X+3,A.Y+3,B.X-4,B.Y-4);
     SetFillStyle(SolidFill,ForeColor);
     Bar(A.X,A.Y,B.X-1,A.Y+FontSize);
     SetFillStyle(SolidFill,BackColor);
     CloseButton.Fill;
     SetLineStyle(Solidln,0,NormWidth);
     CloseButton.Center(T);
     SetFillStyle(SolidFill,ForeColor);
     Bar(T.X-3,T.Y-1,T.X+3,T.Y+1);
     SetLineStyle(SolidLn,0,1);
     SetTextStyle(0,HorizDir,1);
     SetTextJustify(CenterText,TopText);
     SwapColors;
     if Title<>nil then DrawTextXY((A.X+B.x)div 2,A.Y,Title^);
     SwapColors;
    end;
   Cursor^.Show;
  P:=First;
  While P<>nil do
   begin
    P^.Draw;
    P:=P^.NextControl;
   end;
end;
Procedure TDialog.Hide;
begin
 Dec(Visible);
 if  Visible<>0 then exit;
 if SavePtr<>nil then
  begin
   PutPixel(0,0,GetPixel(0,0));
   Cursor^.Hide;
   PutImage(Limits.A.X,Limits.A.Y,SavePtr^,NormalPut);
   Cursor^.Show;
   DisposeImage(SavePtr);
   SavePtr:=nil;
  end
 else PutEvent(cmRedraw,0,0);
 flags:=Flags and not vfVisible;
end;

function TDialog.Next(P:PControl):PControl;
begin
 if  P^.nextControl = nil then Next:=First else NExt:=P^.NextControl;
end;

function TDialog.Prev(P:PControl):PControl;
var Q:PControl;
begin
 if P=First then Prev:=Last
  else
   begin
    Q:=First;
    While q^.NextControl<>p do Q:=Q^.NextControl;
    Prev:=Q;
   end;
end;
Function TDialog.Last:PControl;
var Q:PControl;
   begin
    Q:=First;
    While q^.NextControl<>nil do Q:=Q^.NextControl;
    Last:=Q;
   end;
Function TDialog.Insert(P:PControl):PDialog;
begin
 if P=nil then exit;
 if First<>nil then
  Last^.NextControl:=P else First:=P;
 P^.Owner:=@Self;
 P^.Limits.Intersect(Limits);
 Current:=P;
 Insert:=@Self;
end;
Procedure TDialog.PutCommand(Command:Integer);
begin
  CommandPool:=Command;
end;
function TDialog.Handle(Code:Word):Integer;
var CMD:Integer;
    P:TPoint;
    B:Byte;
    Start:PControl;
function BroadCast:integer;
var Q:PControl;
begin
 Q:=Start;
 Cmd:=0;
 if Q<>nil then
 Repeat
  if (Code<=kbButtonReleased)or(Code>kbMouseMoved+7)or Q^.Limits.Contains(Event) then
   Cmd:=Q^.handle(Code);
   Q:=Next(Q);
   if (Cmd<0)and(cmd<>cmEventProcessed) then
    begin
     PutCommand(abs(Cmd));
     Start:=Q;
    end;
 Until (Cmd<>0) or (Q=Start);
 BroadCast:=cmd;
end;
begin
Start:=Current;
Repeat
 CommandPool:=0;
 Case Code of
 kbMousePressed..kbMousePressed+7:
  begin
   if CloseButton.Contains(Event) then
    begin
     Handle:=cmClose;
    end
   else
    if Limits.Contains(Event) then
    Handle:=broadcast else Handle:=0;
   end;
  kbEsc:
       begin
         Handle:=cmClose;
       end;
  kbTab:begin
     SelectNext;Handle:=cmEventPRocessed;
     end;
  kbShiftTab:Begin SelectPrev;Handle:=cmEventProcessed;end;
  kbMouseMoved+1:begin
                  if Limits.Contains(Event) and (Event.Y<Limits.A.Y+FontSize) then
                   Drag(kbMouseReleased);
                   Handle:=cmEventProcessed;
                 end;
  kbCtrlF5:begin
    Drag(kbEnter);Handle:=cmEventProcessed
    end;
  else
   Handle:=BroadCast;
  end;
 Code:=CommandPool;
 Until CommandPool=0;
end;

Procedure TDialog.Center;
begin
     With Limits Do
       Self.Move((MaxGraphX-B.X-A.X)div 2,(MaxGraphY-B.Y-A.Y)div 2);
end;
Function TDialog.Execute:Integer;
var BiosShift: byte absolute $40:$17;
    Cmd:Integer;Key:Word;P:TPoint;Shift:byte;
begin
  if Flags and vfCentered <>0 then Center;
 Draw;
 DisableKeyMove;
 Repeat
  Key:=GetEvent;
  if (Key >=kbButtonReleased)and(Key<=kbCursorMoved+$FF) then
   Inc(key,$800);{  ⠩ ࠭⫨  ᮡ  }
  cmd:=Handle(Key);
 until Cmd>0;
 Execute:=Cmd;
 Hide;
 EnableKeyMove;
end;

Destructor TDialog.Done;
begin
 While Visible>0 do hide;
 if Title<>nil then DisposeStr(Title);
 Current:=First^.NextControl;
 While First<>nil do
  begin
   Dispose(First,Done);
   First:=Current;
   if First<>nil then Current:=First^.NextControl;
  end;
end;


Procedure TDialog.SetData(var Rec);
var Data:Array[0..65521]of byte absolute rec;
    Index:word;
    Q:PControl;
begin
 Cursor^.Hide;
 Q:=First;
 Index:=0;
 While Q<>nil do
  begin
   Q^.SetData(Data[Index]);
   Inc(Index,Q^.DataSize);
   Q:=Q^.NextControl;
  end;
 Cursor^.Show;
end;
Procedure TDialog.GetData(var Rec);
var Data:Array[0..65521]of byte absolute rec;
    Index:word;
    Q:PControl;
begin
 Q:=First;
 Index:=0;
 While Q<>nil do
  begin
   Q^.getData(Data[Index]);
   Inc(Index,Q^.DataSize);
   Q:=Q^.NextControl;
  end;
end;
Function TDialog.DataSize:Word;
var Index:word;
    Q:PControl;
begin
 Q:=First;
 Index:=0;
 While Q<>nil do
  begin
   Inc(Index,Q^.DataSize);
   Q:=Q^.NextControl;
  end;
 DataSize:=Index;
end;
Procedure TDialog.SelectControl(AControl:PControl);
var P:PControl;
begin
 P:=Current;
 Current:=Acontrol;
 P^.Unselect;
 Current^.Select;
end;
Function TDialog.SelectNext:PDialog;
var P:PControl;
begin
 P:=Current;
 Repeat
 P:=Next(P);
 Until P^.Flags and vfSelectable<>0;
 SelectControl(P);
 SelectNext:=@Self;
end;
Function TDialog.SelectPrev:PDialog;
var P:PControl;
begin
 P:=Current;
 Repeat
 P:=Prev(P);
 Until P^.Flags and vfSelectable<>0;
 SelectControl(P);
 SelectPrev:=@Self;
end;
{*********************** TControl **************************************}
Constructor TControl.Init(X1,Y1,X2,Y2:Integer);
begin
 TObject.Init;
 Limits.Assign(x1,y1,x2,y2);
end;
Procedure TControl.Draw;
begin
 Abstract;
end;
Procedure TControl.Move(DX,DY:integer);
begin
 Limits.Move(DX,DY);
end;
Function TControl.Visible:Boolean;
begin
 Visible:=(Owner<>nil) and (Owner^.Visible>0)
end;
Procedure TControl.Select;
begin
end;
Procedure TControl.Unselect;
begin
end;
function TControl.Handle(Code:Word):Integer;
begin
 Handle:=0;
end;
Procedure TControl.SetData(var Rec);
begin
end;
Procedure TControl.GetData(var Rec);
begin
end;
Function TControl.DataSize:Word;
begin
 DataSize:=0;
end;
Procedure TControl.GetControlPtr(Var S:TStream;var P:PControl);
begin
 P:=nil;
 S.Read(P,2);
 LinkList^.Insert(@P);
end;
Procedure TControl.PutControlPtr(Var S:TStream;P:PControl);
var I:Integer;
begin
 I:=Owner^.IndexOf(P);
 S.Write(I,2);
end;
{********************** TButton ************************************}
constructor TButton.Init(X1,Y1,X2,Y2:integer;AText:STring;ACommand:Integer;ADefault:Boolean);
begin
 TControl.Init(X1,Y1,X2,Y2);
 Text:=NewStr(Atext);
 Cmd:=ACommand;
 Default:=ADefault;
 Flags:=Flags or vfSelectable;
end;
Constructor TButton.Load(var S:TStream);
begin
 TControl.Load(S);
 Text:=S.ReadStr;
 S.Read(Cmd,2);
 S.Read(Default,1);
end;
Procedure TButton.Store(var S:TStream);
begin
 TControl.Store(S);
 S.WriteStr(Text);
 S.Write(Cmd,2);
 S.Write(Default,1);
end;
Procedure TButton.Select;
begin
 Owner^.ButtonSelected:=True;
 Owner^.PutCommand(cmButtonSelected);
end;
Procedure TButton.Unselect;
begin
 Owner^.ButtonSelected:=False;
 Owner^.PutCommand(cmButtonSelected);
end;
Procedure TButton.MakeDefault;
begin
 Default:=True;
 Draw;
 Owner^.PutCommand(-cmDefaultChanged);
end;
Procedure TButton.Draw;
var R:TGrRect;P:TPoint;A:Byte;
begin
 Cursor^.Hide;
 SetFillStyle(SolidFill,BackColor);
 Limits.Fill;
 SetColor(ForeColor);
 SetLineStyle(Solidln,0,NormWidth);
 R.Copy(Limits);
 Dec(R.B.X);Dec(R.B.Y);
 R.Draw;
 if  DisabledCommand(Cmd) then
  A:=taItalic
 else
  begin
        A:=taNormal;
        SetLineStyle(SolidLn,0,ThickWidth);
        Line(R.A.X+2,R.B.Y,Limits.b.X,R.B.Y);
        Line(R.b.X,Limits.A.Y+2,R.b.X,Limits.B.Y);
  end;
 SetTextJustify(CenterText,CenterText);
 SetTextStyle(0,HorizDir,1);
 R.Center(P);
 DrawTextXY(P.X,P.Y,Tilda2CC(Text^,A,A+taUnderline));
  if Default and not Owner^.ButtonSelected or (Owner^.Current=@Self) then
  With Limits do
  begin
   SetTextJustify(LeftText,Centertext);
   OutTextXY(A.X+2,(A.Y+B.Y) div 2 -1,'');
   SetTextJustify(RightText,CenterText);
   OutTextXY(B.X-2,(A.Y+B.Y) div 2 -1,'');
  end;
 Cursor^.Show;
end;
function TButton.Handle(Code:Word):Integer;
begin
 {$R-}
 if (Hi(Code)<>0) and (Hi(Code)=GetScanCode(HotChar(Text^))) or
  ((Code and $FF00)=kbMousePressed) or
  (((Code=kbEnter)or(Code=kbGrayEnter))and
  (Default and not Owner^.ButtonSelected or (Owner^.Current=@Self)))
  and not DisabledCommand(Cmd) then
   begin
    Press;
    Handle:=cmd;
    end else
   if (Cmd<0)and(Code=-Cmd) then
     Handle:=Code else
    begin
     Handle:=0;
     if Code=cmButtonSelected then Draw
      else if Code=cmDefaultChanged then begin Default:=False; Draw end;
   end;
end;
Procedure TButton.Press;
var S:Integer;P:Pointer;
    T:LongInt;
    Timer:LongInt absolute $40:$6C;
begin
 With Limits do
  begin
   S:=ImageSize(A.X,A.Y,B.X-2,B.Y-2);
   SetFillStyle(SolidFill,BackColor);
   SetLineStyle(SolidLn,0,ThickWidth);
   SetColor(ForeColor);
   GetMem(P,S);
   Cursor^.hide;
   GetImage(A.X,A.Y,B.X-2,B.Y-2,P^);
   Bar(A.X,A.Y,B.X-2,B.Y-2);
   PutImage(A.X+2,A.y+2,P^,NormalPut);
   Cursor^.Show;
   T:=Timer;
   Repeat Until T<>Timer;
   Cursor^.Hide;
   Line(A.X+2,B.y-1,B.X,B.Y-1);
   Line(B.X-1,A.y+2,B.X-1,B.Y);
   PutImage(A.X,A.Y,P^,NormalPut);
   Cursor^.Show;
   FreeMem(P,S);
  end;
end;
Destructor TButton.Done;
begin
 DisposeStr(Text);
 TControl.done
end;
{************************** TGraphicText ********************************}
Constructor TGraphicText.Init(X1,y1,x2,y2:Integer;Atext:String;AFont:Byte;
                                Aflags:Word);
begin
 TControl.Init(X1,Y1,X2,Y2);
 Text:=NewStr(AText);
 Font:=AFont;
 Flags:=AFlags;
 if Flags and $3F=0 then
 Flags:=Flags or 1;
end;
Constructor TGraphicText.Load(var S:TStream);
begin
 TControl.Load(S);
 Text:=S.ReadStr;
 S.Read(Font,SizeOf(Font));
 S.Read(Flags,SizeOf(Flags));
end;
Procedure TGraphicText.Store(var S:TStream);
begin
 TControl.Store(S);
 S.WriteStr(Text);
 S.Write(Font,SizeOf(Font));
 S.Write(Flags,SizeOf(Flags));
end;
Procedure TGraphicText.Draw;
var VAlign,HAlign:Integer;
    DX,DY,MX,MY:Integer;
    S:String;
Function Calc(Align,X1,X2:Integer):Integer;
var Clc:Integer;
begin
 Case Align of
 0:Clc:=X1;
 1:Clc:=(X1+X2)div 2;
 2:Clc:=X2;
 end;
 Calc:=Clc
end;
{var TextInfo:TextSettingsType;}
Begin
 Cursor^.Hide;
 SetFillStyle(SolidFill,BackColor);
  SetTextStyle(Font,HorizDir,Flags and $3F);
  if Font<>0 then SetUserCharSize(1,1,1,1);
  VAlign:=(Flags and $C00) shr 10;
  HAlign:=(Flags and $3000) shr 12;
  if Flags and tfFillBoth<>0 then
  With Limits Do
   begin
    DY:=-1;MY:=-1;
    if (Flags and tfFillVert<>0)or(TextHeight(Text^)>(B.Y-A.Y)) then
     begin
      MY:=B.Y-A.Y;
      DY:=TextHeight(Text^);
     end;
    if (Flags and tfFillHoriz<>0)or
     (Abs(MY*TextWidth(Text^))>Abs(DY*(B.X-A.X))) then
     begin
      MX:=B.X-A.X;
      DX:=TextWidth(Text^);
      if DY<0 then begin DY:=DX;MY:=MX end;
{       else
             IF mx*dY > mY/DX THEN
       BEGIN
     DY:=DX;MY:=MX end;}

     end else
      begin
       DX:=DY;
       MX:=MY;
      end;
    if DX>MaxGraphX then
     begin
      DX:=MaxGraphX;
      MX:=LongMul(MX,MaxGraphY) div DX;
     end;
    if DY>MaxGraphY then
     begin
      DY:=MaxGraphY;
      MY:=LongMul(MY,MaxGraphY) div DY;
     end;
    if Font<>0 then SetUserCharSize(MX,DX,MY,DY);
  end;
  SetColor(ForeColor);
  SetTextJustify(HAlign,VAlign);
  if Font=0 then S:=AdjustString(Text^,(Limits.B.X-Limits.A.X)div 8)
   else
    begin
     S:=Text^;

     While TextWidth(S)>(Limits.B.X-Limits.A.X) do dec(S[0]);
    end;
  With Limits do
  OutTextXY(Calc(HAlign,A.x,B.x),Calc(2-VAlign,A.Y,B.Y),S);
  Cursor^.Show;
end;
Destructor TGraphicText.Done;
begin
 if Text<>nil then DisposeStr(Text);
 TControl.Done;
end;
{********************* TPicture *******************************}
Constructor TPicture.Init (X1,y1,X2,y2:Integer;ABitMap:Pointer;ADeallocate:Boolean);
begin
 TControl.Init(X1,Y1,X2,Y2);
 BitMap:=ABitMap;
 Deallocate:=ADeallocate;
end;
Constructor TPicture.Load(var S:TStream);
var BSize:Integer;
begin
 TControl.Load(S);
 GetMem(BitMap,BitSize);
 S.Read(BitMap^,BitSize);
 Deallocate:=True;
end;
Procedure TPicture.Store(var S:TStream);
begin
 TControl.Store(S);
 S.Write(BitMap^,BitSize);
end;
Procedure TPicture.Draw;
var P:PImage;
begin
   With Limits do
   P:=Bits2Image(B.X-A.X,B.Y-A.Y,BitMap^,ForeColor,BackColor);
   Cursor^.Hide;
   With Limits.A do
   PutImage(X,Y,P^,CopyPut);
   Cursor^.show;
   DisposeImage(P);
end;
Destructor TPicture.Done;
var BSize:Integer;
begin
 if Deallocate then
 FreeMem(BItMap,BitSize);
end;
Function TPicture.BitSize:Word;
begin
 With Limits do
   BitSize:=(B.Y-A.Y)*((B.X-A.X+7) div 8 );
end;
{********************* TPictoGram *************************************}
var Timer:Word absolute $40:$6C;
Constructor TPictogram.Init(X1,y1,X2,y2:Integer;ABitMap:Pointer;
                 ADeallocate:Boolean;Command:Integer);
begin
 TPicture.Init(X1,Y1,X2,Y2,ABitMap,ADeallocate);
 PrevTime:=Timer shr 1;
 Cmd:=Command;
 Flags:=Flags or vfSelectable;
end;
function TPictogram.Handle(Code:Word):Integer;
var T:word;
Const Pattern:Array[Boolean] of Word=($0F0F,$F0F0);
begin
 if Visible and (Owner^.Current=@Self) then
  begin
   T:=Timer shr 1;
   if T<>PrevTime then
    begin
     SetColor(BackColor);
     SetLineStyle(UserBitLn,Pattern[Odd(T)],NormWidth);
     Limits.Draw;
     SetColor(ForeColor);
     SetLineStyle(UserBitLn,Pattern[not odd(T)],NormWidth);
     Limits.Draw;
     PrevTime:=T;
    end;
   end;
   if ((Code=kbEnter)or(Code=kbGrayEnter)) and (Owner^.Current=@Self) or
    (Code and $FF00=kbMousePressed) then
     begin
      SwapColors;
      Draw;
      Repeat until Timer shr 1<>PrevTime;
      SwapColors;
      Draw;
      Handle:=Cmd
     end
    else Handle:=0;
end;
Constructor TPictogram.Load(var S:TStream);
begin
 TPicture.Load(S);
 S.Read(Cmd,2);
 PrevTime := Timer shr 1;
end;
Procedure TPictogram.Store(var S:TStream);
begin
 TPicture.Store(S);
 S.Write(Cmd,2);
end;
Procedure TPictogram.Select;
begin
 Owner^.ButtonSelected:=True;
 Owner^.PutCommand(cmButtonSelected);
end;

Procedure TPictogram.Unselect;
begin
 Cursor^.Hide;
 Owner^.ButtonSelected:=False;
 Owner^.PutCommand(cmButtonSelected);
     SetColor(BackColor);
     SetLineStyle(SolidLn,0,NormWidth);
     Limits.Draw;
 Cursor^.Show;
end;
{**************************** TInputLine ******************************}
Constructor TInputLine.Init(X1,Y1,X2,Y2,AMaxLen:Integer);
begin
 TControl.Init(X1,y1,X2,Y2);
 GetMem(Data,AMaxLen+1);
 DispLen:=(X2-X1-2) div 8 - 2;
 MAxLen:=AMaxLen;
 Data^:='';
 StartPos:=1;
 CurPos:=1;
 ClearEntry:=True;
 FillChar(Data^[1],MaxLen,' ');
 Flags:=Flags or vfSelectable;
end;
Constructor TInputLine.Load(var S:TStream);
begin
 TControl.Load(S);
 S.Read(Maxlen,2);
 GetMem(Data,MaxLen+1);
 S.Read(DispLen,2);
 Data^:='';
 StartPos:=1;
 CurPos:=1;
 ClearEntry:=True;
end;
Procedure TInputLine.Store(var S:TStream);
begin
 TControl.Store(S);
 S.Write(MaxLen,2);
 S.Write(DispLen,2);
end;
Procedure TInputLine.SetData(var Rec);
begin
 FillChar(Data^[1],MaxLen,' ');
 System.Move(Rec,Data^,Byte(Rec)+1);
  CurPos:=1;
  StartPos:=1;
  if CurPos-StartPos>=DispLen then StartPos:=CurPos-Pred(DispLen);
  ClearEntry:=True;
  if Visible then Draw;
end;
Procedure TInputLine.GetData(var Rec);
Begin
  System.Move(Data^,Rec,MaxLen+1);
end;

Function TInputLine.DataSize:Word;
begin
 DataSize:=Succ(MaxLen);
end;
Procedure TInputLine.Draw;
var R:TGrRect;P:TPoint;I:Integer;S:String;
begin
 SetLineStyle(SolidLn,0,NormWidth);
 SetColor(BackColor);
 Cursor^.Hide;
 MoveTo(Limits.A.X+1,Limits.A.Y+1);
 if StartPos>1 then DrawText('') else DrawText(' ');
 SwapColors;
 S[0]:=Chr(DispLen);
 i:=Byte(Data^[0])-StartPos+1;
 if I>DispLen then I:=DispLen;
 FillChar(S[1],80,' ');

 System.Move(Data^[StartPos],S[1],i);
 DrawText(s);
 SwapColors;
 if StartPos+DispLen<=Length(Data^) then DrawText(#26) else DrawText(' ');
 SetColor(ForeColor);
 Limits.Draw;
 Cursor^.Show;
 if Owner^.Current=@Self then DrawCursor(True);
end;
Procedure TInputLine.Select;
begin
 ClearEntry:=True;
 if Visible then Draw;
end;
Procedure TInputLine.Unselect;
begin
 if Visible then DrawCursor(False);
end;
Procedure TInputLine.DrawCursor(On:Boolean);
begin
 Cursor^.Hide;
 MoveTo(Limits.A.X+(CurPos-Pred(StartPos))*8,Limits.A.Y+1);
 if not on then SwapColors;
 DrawChar(Data^[CurPos]);
 if not on then SwapColors;
 Cursor^.Show;
end;
Function TInputLine.Handle(Code:Word):Integer;
var P:TPoint;B:Byte;
Procedure CursorRight;
begin
 DrawCursor(False);
 if CurPos<=Length(Data^) then inc(CurPos);
 if CurPos>Length(Data^) then Data^[CurPos]:=' ';
 if CurPos>=StartPos+DispLen then
  begin
   inc(StartPos);Draw;
  end
 else DrawCursor(True);
end;
Procedure CursorLeft;
begin
 DrawCursor(False);
 if CurPos>1 then Dec(CurPos);
 if CurPos<StartPos then begin StartPos:=CurPos;Draw end
  else DrawCursor(True);
end;
Procedure Home;
begin
		 DrawCursor(False);
         CurPos:=1;
         if StartPos>1 then begin StartPos:=1;draw end
          else
		  DrawCursor(True);
        end;
Procedure  EndLine;
 Begin
		DrawCursor(False);
        CurPos:=Succ(Length(data^));
        if StartPos+DispLen<=CurPos then
         begin
          StartPos:=CurPos-Pred(DispLen);
          Draw;
         end
		else DrawCursor(True);
       end;
Procedure DelCh;
begin
 Delete(Data^,CurPos,1);
 Data^[Succ(Length(Data^))]:=' ';
 Draw;
end;
Procedure InsCH(ch:Char);
begin
 if ClearEntry then begin data^:='';CurPos:=1;StartPos:=1 end;
 if (CurPos>Length(data^)) or (ShiftStatus and $80<>0)then
  if Length(data^)=MaxLen then
   begin Beep;exit end else
   Insert(ch,data^,CurPos)
 else Data^[CurPos]:=Ch;
 CursorRight;
 Draw;
end;
Begin
 if (Owner^.Current<>@Self)
    and(Code<kbMouseReleased)
  then begin Handle:=0;exit end;
 Case Code of
 kbBackSpace:if CurPos>1 then begin CursorLeft;DelCh end;
 kbDel:DelCh;
 kbLeft:if CurPos>1 then CursorLeft;
 kbRight:If CurPos<=Length(Data^) then CursorRight;
 kbHome:Home;
 kbEnd:EndLine;
 kbMousePressed..kbMousePressed+$FF:
       begin
        Owner^.SelectControl(@Self);
		DrawCursor(False);
        B:=(Event.X-Limits.A.X) div 8;
        if B=0 then
		  begin DrawCursor(True);Home end
         else
          if B>DispLen then
		   begin DrawCursor(True);End
         else
		  begin CurPos:=StartPos+Pred(B);DrawCursor(True) end;
       end;
 else
 if (Hi(Code)>1) and(Hi(Code)<>$1C)and(Lo(Code)<>0)or(Code=$300) then
  InsCh(chr(Lo(Code))) else begin Handle:=0;exit end;
 end;
 Handle:=cmEventProcessed;
 ClearEntry:=False;
end;
Destructor TInputLine.Done;
begin
 FreeMem(Data,MaxLen+1);
 TControl.Done;
end;
{*************************** TTextLine ****************************}
Procedure TTextLine.Draw;
var S:String;Width:Integer;
begin
 With limits do
 Width:=(B.X-A.X)div 8;
 SetFillStyle(SolidFill,BackColor);
 Cursor^.Hide;
 S:=GetText;
 MoveTo(Limits.A.X,Limits.A.Y);
 DrawText(AdjustString(S,Width));
 Cursor^.Show;
end;
Function TTextLine.GetText:String;
begin
 Abstract;
end;
{*********************** TStaticText ***************************}
Constructor TStaticText.Init(X1,Y1,X2,Y2:integer;Atext:String);
begin
 TTextLine.Init(X1,Y1,X2,Y2);
 Text:=NewStr(AText);
end;
Constructor TStaticText.Load(var S:TStream);
begin
 TControl.Load(S);
 Text:=S.ReadStr;
end;
Procedure TStaticText.Store(var S:TStream);
begin
 TControl.Store(S);
 S.WriteStr(Text);
end;
Function TStaticText.GetText:String;
begin
 if Text=nil then GetText:='' else GetText:=Text^;
end;
Destructor TStaticText.Done;
begin
 DisposeStr(Text);
 TTextLine.Done;
end;
{*************************  TLabel ********************************}
Constructor TLabel.Init(X1,Y1,X2,Y2:integer;Atext:String;ALink:PControl);
begin
 TStaticText.Init(X1,Y1,X2,Y2,Tilda2CC(AText,0,taUnderline));
 Scan:=GetScanCode(HotChar(Atext));
 Link:=Alink;
end;
Constructor TLabel.Load(var S:TStream);
begin
 TStaticText.Load(S);
 GetControlPtr(S,Link);
 S.Read(Scan,1);
end;
Procedure TLabel.Store(var S:TStream);
begin
 TStaticText.Store(S);
 PutControlPtr(S,Link);
 S.Write(Scan,1);
end;
Function TLabel.Handle(Code:Word):Integer;
begin
 if ((Code and $FF00)=kbMousePressed)or(Scan<>0)and(Hi(Code)=Scan) then
  begin
   Owner^.SelectControl(Link);
   Handle:=cmEventProcessed;
  end else Handle:=0;
end;
{*************************  TViewLine   ***************************}
Constructor TViewLine.Init(X1,Y1,X2,Y2,AMaxLen:Integer);
begin
 TTextLine.Init(X1,Y1,X2,Y2);
 GetMem(Text,AMaxlen+1);
 MaxLen:=AMaxLen;
 Text^:='';
end;
Constructor TViewLine.Load(var S:TStream);
begin
 TControl.Load(S);
 S.Read(MaxLen,2);
 GetMem(Text,MaxLen+1);
 Text^:='';
end;
Procedure TViewLine.Store(var S:TStream);
begin
 TControl.Store(S);
 S.Write(MaxLen,2);
end;
Procedure TViewLine.SetData(var Rec);
begin
 System.Move(Rec,Text^,MaxLen+1);
 If Visible then Draw;
end;
Function TViewLine.GetTExt:String;
begin
 GetText:=Text^;
end;
Procedure TViewLine.GetData(var Rec);
begin
 System.Move(Text^,Rec,MaxLen+1);
 If Visible then Draw;
end;
Function TViewLine.DataSize:Word;
begin
 DataSize:=MaxLen+1;
end;
Destructor TViewLine.Done;
begin
 FreeMem(Text,MaxLen+1);
 TTextLine.Done;
end;
{************************* TBorder ********************************}
Procedure TBorder.Draw;
begin
 Cursor^.Hide;
 SetColor(ForeColor);
 SetLineStyle(SolidLn,0,NormWidth);
 Limits.Draw;
 Cursor^.Show;
end;
{*************************  TScrollBar  ***************************}
Constructor TScrollBar.Init(X1,y1,x2,y2:Integer;Vertical:Boolean);
begin
 TControl.Init(X1,Y1,X2,Y2);
 Vert:=Vertical;
end;
Constructor TScrollBar.Load(var S:TStream);
begin
 TControl.Load(S);
 S.Read(Vert,1);
 GetControlPtr(S,Link);
end;
Procedure TScrollBar.Store(var S:TStream);
begin
 TControl.Store(S);
 S.Write(Vert,1);
 PutControlPtr(S,Link);
end;
Procedure TScrollBar.Draw;
var R,B:TGrRect;
    V:Integer;
begin
 Cursor^.Hide;
 SetLineStyle(SolidLn,0,NormWidth);
 SetColor(ForeColor);
 Limits.Draw;
 R.Copy(Limits);
 if Vert then begin
               R.Grow(-1,-8);
               V:=R.B.Y-R.A.Y;
              end
         else
            begin
               R.Grow(-8,-1);
               V:=R.B.X-R.A.X;
            end;
 SetFillPattern(GrayFill,GetMaxColor);
 R.Fill;
 R.Draw;
 if size<>0 then
 V:=LongMul(Pos,V) div Size;
 if Vert then B.Assign(R.A.X,R.A.Y+V,R.B.X,R.A.Y+V+8)
         else  B.Assign(R.A.X+V,R.A.Y,R.A.X+V+8,R.B.Y);
 B.InterSect(R);
 SetFillStyle(SolidFill,GetMaxColor);
 B.Fill;
 SetColor(ForeColor);
 B.Draw;
 if Vert Then
  begin
   B.A.X:=(Limits.A.X+Limits.B.X)div 2;
   B.B.Y:=Limits.A.Y+4;
   B.B.x:=B.A.X;
   B.A.Y:=Limits.B.Y-4;
   SetTextStyle(0,VertDir,1);
  end
 else
  begin
   B.A.X:=Limits.A.X+4;
   B.A.Y:=(Limits.A.Y+Limits.B.Y)div 2;
   B.B.X:=Limits.B.X-4;
   B.B.Y:=B.A.Y;
   SetTextStyle(0,HorizDir,1);
  end;
 SetTextJustify(CenterText,CenterText);
 OutTextXY(B.A.X,B.A.Y,'');
 OutTextXY(B.B.X,B.B.Y,'');
 Cursor^.Show;
end;
Procedure TScrollBar.Unselect;
begin
 if (Flags and vfSelectable<>0)and(Visible) then
  begin
   SetLineStyle(SolidLn,0,NormWidth);
   SetColor(ForeColor);
   Cursor^.Hide;
   Limits.Draw;
   Cursor^.Show;
  end;
end;
Procedure TScrollBar.SetParams(ASize,APos,AArStep,APgStep:Integer);
begin
 Size:=ASize;
 Pos:=APos;
 ArStep:=AArStep;
 PgStep:=APgStep;
 If (Owner<>nil)and(Visible)then Draw;
end;
Function TScrollBar.GetPos:Integer;
begin
 GetPos:=Pos;
 Changed:=False;
end;
Function TScrollBar.Handle(Code:Word):Integer;
Var R:TRect;A,W:Integer;
Procedure DecPos(Step:Integer);
begin
 if Pos>Step then Dec(Pos,Step) else Pos:=0;
 Draw;
 Changed:=True;
end;

Procedure IncPos(Step:Integer);
begin
 Inc(Pos,Step); if Pos>=Size then Pos:=Pred(Size);
 Draw;
 Changed:=True;
end;
Procedure BlinkFrame;
var T:LongInt;
const    Pattern:Array[Boolean] of Word=($0F0F,$F0F0);
begin
   T:=Timer shr 1;
   if T<>PrevTime then
    begin
     Cursor^.Hide;
     SetColor(BackColor);
     SetLineStyle(UserBitLn,Pattern[odd(T)],NormWidth);
     Limits.Draw;
     SetColor(ForeColor);
     SetLineStyle(UserBitLn,Pattern[not Odd(T)],NormWidth);
     Limits.Draw;
     PrevTime:=T;
     Cursor^.Show;
    end;

end;
begin
 Handle:=0;
 if Owner^.Current=@Self Then BlinkFrame;
 if (Code and $FF00= kbMousePressed )and(link<>nil) then
  Owner^.SelectControl(Link);
 if (Owner^.Current<>link)and(Owner^.Current<>@Self) then exit;
 case Code of
 kbLeft:if not Vert then DecPos(ArStep) else exit;
 kbRight:if not Vert then IncPos(ArStep) else exit;
 kbUp:if Vert Then DecPos(ArStep) else exit;
 kbDown: if Vert then IncPos(ArStep) else exit;
 kbPgUp:If Vert then DecPos(PgStep) else exit;
 kbPgDn:If Vert then IncPos(PgStep) else exit;
 kbCtrlLeft:if Not Vert then DecPos(PgStep) else exit;
 kbCtrlRight:if Not Vert then IncPos(PgStep) else exit;
 kbMousePressed..kbMousePressed+$FF:
{1}begin
    if not Limits.Contains(Event) then exit;
    if Flags and vfSelectable<>0 then Owner^.SelectControl(@Self);
    R.Copy(Limits);
    if Vert then R.B.Y:=R.A.Y+7 else R.B.X:=R.A.X+7;
    if R.Contains(Event) then DecPos(ArStep)
     else
      begin
       R.Copy(Limits);
       if Vert then R.A.Y:=R.B.Y-7 else R.a.X:=R.B.X-7;
       if R.Contains(Event) then IncPos(ArStep)
        else
         begin
          if Vert then
           begin
             A:=Event.Y-Limits.A.Y-8;
             W:=Limits.B.Y-Limits.A.Y-16;
           end
          else
           begin
            A:=Event.X-Limits.A.X-8;
            W:=Limits.B.X-Limits.A.X-16;
           end;{________of if}
          Pos:=LongMul(A,Size) div W;
          Changed:=True;
          Draw;
         end;
      end;
   end;
 else
  Exit;
 end;{____of Case}
Handle:=-cmScrolling;
end;{TScrollBar.Handle}
Constructor TListBox.Init(X1,Y1,X2,Y2:Integer;AScrollBar:PScrollBar);
begin
 X2:=(X2-X1-2) and $FFF8 +X1+2;
 TControl.Init(X1,Y1,X2,y2);
 VisItems:=Pred((Y2-Y1-2)div fontSize);
 ScrollBar:=AScrollBar;
 if ScrollBar<>nil then ScrollBar^.Link:=@Self;
 ScrollTo(0);
 Flags:=Flags or vfSelectable;
end;
Constructor TListBox.Load(var S:TStream);
begin
 TControl.Load(S);
 S.Read(VisItems,2);
 GetControlPtr(S,PControl(ScrollBar));
end;
Procedure TListBox.Store(var S:TStream);
begin
 TControl.Store(S);
 S.Write(VisItems,2);
 PutControlPtr(S,ScrollBar);
end;
Procedure TListBox.Draw;
var I:Integer;
begin
 Cursor^.Hide;
 SetLineStyle(SolidLn,0,NormWidth);
 SetColor(ForeColor);
 Limits.Draw;
 For I:=TopItem to TopItem+VisItems do
  DrawItem(i);
 Cursor^.Show;
end;
Procedure TListBox.SelectItem(Item:Integer);
begin
end;
Function TListBox.IsSelected(Item:Integer):Boolean;
begin
 isSelected:=False;
end;
Procedure TListBox.DrawItem(Item:Integer);
var Y:Integer;S:String;Width:Integer;
Const SelectChar:array[Boolean] of Char=' ';
begin
 if not visible then exit;
 With Limits do
 Width:=(B.X-A.X-2) div 8;
 Cursor^.Hide;
 Y:=(Item-TopItem)*FontSize+Limits.A.Y+1;
 MoveTo(Limits.A.X+1,Y);
 if (Item=Focused)and
  (Owner^.Current=@Self) then
  begin
   SwapColors
  end;
  if (Item>=TopItem)and(Item<=TopItem+VisItems) then
   begin
    if Item<Range Then S:=SelectChar[isSelected(Item)]+GetText(Item)
                       else S:='';
    DrawText(AdjustString(S,Width));
   end;
 if (Item=Focused) then
 if  (Owner^.Current<>@Self) then
  begin
   SetColor(ForeColor);
   SetLineStyle(SolidLn,0,NormWidth);
   RectAngle(Limits.A.X+1,Y,Limits.B.X-2,Y+Pred(FontSize));
  end else SwapColors;
  Cursor^.Show;
end;
Function TListBox.GetText(Item:Integer):String;
var P:PString;
begin
 P:=List^.At(Item);
 if P=nil then GetTExt:='' else
 GetText:=P^;
end;
Procedure TListBox.SetData(Var Rec);
var Data:TListBoxRec absolute Rec;
begin
 if (Data.Focused<0) then
  Focused:=0 else Focused:=Data.Focused;
 NewList(Data.List);
end;
Procedure TListBox.GetData(var Rec);
var Data:TListBoxRec absolute Rec;
begin
  Data.List:=List;
  Data.Focused:=Focused;
end;
Procedure TListBox.NewList(AList:PCollection);
begin
 if List<>nil then Dispose(List,Done);
 List:=AList;
 if List<>nil then
 Range:=List^.Count else Range:=0;
 if Focused>=Range then Focused := 0;
  ScrollTo(Focused);
end;
Function TListBox.DataSize:word;
begin
 DataSize:=SizeOf(TListBoxRec);
end;
Function TListBox.Handle(Code:Word):Integer;
var ClickedItem:Integer;
begin
 Handle:=cmEventProcessed;
 if (Code=cmScrolling) and (ScrollBar^.Changed) then
  ScrollTo(ScrollBar^.GetPos)
 else
  if (Code>kbMousePressed)and(Code<kbMouseMoved) then
  begin
   Owner^.SelectControl(@Self);
   ClickedItem:=(Event.Y-Limits.A.Y) div FontSize+TopItem;
   if ClickedItem<>Focused then
   ScrollTo(ClickedItem) else SelectItem(ClickedItem);
  end else
  if Code=$3920 then
    SelectItem(Focused)
 else Handle:=0;
end;
Procedure TListBox.ScrollTo(Item:Integer);
begin
 if Item<=0 then Focused:=0 else
  if Item>=Range then Focused:=Pred(Range)
    else Focused:=Item;
 if Focused-TopItem>VisItems then TopItem:=Focused-VisItems
  else if TopItem>Focused then TopItem:=Focused;
 if Seg(ScrollBar^)<>0 then
 if Range<>0 then ScrollBar^.SetParams(Range,Focused,1,VisItems)
  else ScrollBar^.SetParams(1,0,1,VisItems);
 if (Owner<>nil)and(Visible) then Draw;
end;
Procedure TListBox.Select;
begin
 if (Owner<>nil)and(Visible) then DrawItem(Focused);
end;
Procedure TListBox.Unselect;
begin
 DrawItem(Focused);
end;
Function TMultyBox.IsSelected(Item:Integer):Boolean;
begin
 IsSelected:=(Item<255)and(Item in Selected);
end;
Procedure TMultyBox.SelectItem(Item:Integer);
begin
 if Item<=255 then
  if Item In Selected then
   Selected:=Selected-[Item]
  else
   Selected:=selected+[Item];
  DrawItem(Item);
end;
Procedure TMultyBox.SetData(Var Rec);
begin
 TlistBox.SetData(Rec);
 System.Move(TMultyBoxRec(Rec).Selected,Selected,SizeOf(Selected));
end;
Procedure TMultyBox.GetData(var Rec);
begin
 TlistBox.GetData(Rec);
 TMultyBoxRec(Rec).Selected:=Selected;
end;

Function NewSItem(Text:String;Next:PStringNode):PStringNode;
{******************************************************}
{*               NewSItem                             *}
{******************************************************}
var P:PStringNode;
Begin
 GetMem(P,Length(Text)+5);
 Move(Text,P^.S,Length(Text)+1);
 P^.Next:=Next;
 NewSItem:=p;
end;{______of function NewSItem }

{********************** TCluster object *************************}
Constructor TCluster.Init(X1,y1,x2,y2:Integer;Astrings:PStringNode);
begin
 TControl.Init(X1,y1,x2,y2);
 Strings:=AStrings;
 Flags:=Flags or vfSelectable;
end;
Constructor TCluster.Load(var S:TStream);
var PS:PString;
    P,Q:PStringNode;
begin
 TControl.Load(S);
 Q:=Nil;
 Repeat
  PS:=S.ReadStr;
  if PS<>nil then
   begin
    P:=NewSItem(PS^,nil);
    DisposeStr(PS);
    if Q=nil then Strings:=P else Q^.Next:=p;
    Q:=p;
   end;
 Until PS=nil;
end;
Procedure TCluster.Store(var S:TStream);
var P:PStringNode;
begin
 TControl.Store(S);
 P:=Strings;
 while P<>nil do
  begin
   S.WriteStr(@P^.S);
   P:=P^.next;
  end;
 S.WriteStr(nil);
end;
Procedure TCluster.DrawBox(boxNo:Integer);
begin
 Abstract;
end;
Procedure TCluster.Mark(BoxNo:Integer);
begin
 Abstract;
end;
Procedure TCluster.Draw;
var P:PStringNode;
    Width,I,Y:Integer;

begin
 Cursor^.Hide;
 SetLineStyle(SolidLn,0,NormWidth);
 SetColor(ForeColor);
 P:=Strings;
 i:=0;Y:=Limits.A.Y+2;
 Width:=(Limits.B.x-Limits.A.x) div 8 -2;
 While P<>nil do
  begin
   MoveTo(Limits.A.X+16,Y);
   DrawText(AdjustString(Tilda2CC(P^.S,0,taUnderline),Width));
   if (Owner^.Current=@Self)and(I=Sel) then SwapColors;
   DrawBox(I);
   if (Owner^.Current=@Self)and(I=Sel) then SwapColors;
   inc(i);
   Inc(Y,FontSize);
   P:=P^.Next;
  end;
  Cursor^.Show;
end;
Procedure TCluster.SetData(var Rec);
var Data:Word absolute Rec;
begin
 Value:=Data;
end;
Procedure TCluster.GetData(var Rec);
var Data:Word absolute Rec;
begin
 Data:=Value;
end;
Function TCluster.DataSize:Word;
begin
 DataSize:=2;
end;
Procedure TCluster.Select;
begin
 if Visible then Draw;
end;
Procedure TCluster.UnSelect;
begin
 if Visible then Draw;
end;
Function TCluster.Handle(Code:Word):Integer;
var I:Integer;
    T:LongInt;
    BiosTimer:LongInt Absolute $40:$6C;
    P:PStringNode;
begin
  Handle:=0;
  if (Code>kbMousePressed)and(Code<kbMouseMoved) then
   begin
    Owner^.SelectControl(@Self);
    if Event.X<Limits.A.X+16 then
    begin
     Mark((Event.Y-Limits.A.Y)div FontSize);
     Handle:=cmEventProcessed;
    end;
   end
  else
   if Code=kbSpace then
    begin
     Mark(Sel);
     Handle:=cmEventProcessed;
    end
  else if Code=kbUp then
   begin
     DrawBox(Sel);
     if Sel=0 then
     begin
      P:=Strings;
      While P<>nil do
       begin
        P:=P^.Next;
        Inc(Sel);
       end;
      Dec(Sel);
     end
    else Dec(Sel);
    SwapColors;
    DrawBox(Sel);
    SwapColors;
      Handle:=cmEventProcessed;
   end
  else if Code=kbDown then
   begin
    P:=Strings;
    I:=0;
    DrawBox(Sel);
    While I<>Sel do
     begin
      P:=P^.Next;
      Inc(i);
     end;
    if P^.Next<>nil then inc(Sel) else Sel:=0;
    Handle:=cmEventProcessed;
    SwapColors;
    DrawBox(Sel);
    SwapColors;
    end
   else
   if (Hi(Code)>11)or(Lo(Code)<>0) then
    begin
     if (Code>=kbAlt1)and(Code<=kbAlt0) then Dec(Code,$7600);
     P:=Strings;I:=0;
     While (P<>nil)and(Hi(Code)<>GetScanCode(HotChar(P^.S)))do
      begin
       P:=P^.next;
       inc(i);
      end;
     if P<>nil then
      begin
       Owner^.SelectControl(@Self);
       DrawBox(Sel);
       Mark(i);
       SwapColors;
       DrawBox(i);
       SwapColors;
       Handle:=cmEventProcessed;
      end else Handle:=0;
    end
end;
Destructor TCluster.Done;
var P:PStringNode;
begin
 While Strings<>nil do
  begin
   P:=Strings;
   Strings:=Strings^.Next;
   FreeMem(P,Length(P^.S)+5);
  end;
 TControl.Done;
end;
{*************** TCheckBox object *******************************}
Procedure TCheckBox.DrawBox(boxNo:Integer);
var X,Y:Integer;Mask:Word;
begin
 if not visible then exit;
 Cursor^.Hide;
 SetLineStyle(SolidLn,0,NormWidth);
 SetWriteMode(CopyPut);
 X:=Limits.A.X+4;
 Y:=Limits.A.Y+BoxNo*FontSize+2;
 SetColor(ForeColor);
 SetFillStyle(SolidFill,BackColor);
 Bar(X-1,Y-1,X+8,Y+8);
 Rectangle(X,Y,X+7,Y+7);
 Mask:=1 shl boxNo;
 if (Mask and Value)<>0 then
 begin
  Line(X,Y,X+7,Y+7);
  Line(X+7,Y,x,y+7);
 end;
 Cursor^.Show;
end;
Procedure TCheckBox.Mark(BoxNo:Integer);
var Mask:Word;I:Integer;
begin
 Mask:=1 Shl BoxNo;
 Value :=Value XOR Mask;
 if Sel<>BoxNo then
  begin
   I:=Sel;
   Sel:=BoxNo;
   DrawBox(i);
  end;
 SwapColors;
 DrawBox(Sel);
 SwapColors;
end;
{*********************** TRadioButtons object *******************}
Procedure TRadioButtons.DrawBox(boxNo:Integer);
var X,Y:Integer;
begin
 if not Visible then exit;
 Cursor^.Hide;
 SetFillStyle(SolidFill,BackColor);
 SetLineStyle(SolidLn,0,NormWidth);
 X:=Limits.A.X+8;
 Y:=Limits.A.Y+FontSize*BoxNo+5;
 SetColor(BackColor);
 FillEllipse(X,Y,5,5);
 SetColor(ForeColor);
 Circle(X,Y,4);
 if Value=BoxNo then Circle(X,Y,1);
 Cursor^.Show;
end;
Procedure TRadioButtons.Mark(BoxNo:Integer);
var I:Word;
begin
 I:=Value;
 Value:=BoxNo;
 Sel:=Value;
 DrawBox(i);
 SwapColors;
 DrawBox(Sel);
 SwapColors;
end;
Procedure RegisterDlg;
begin
 RegisterType(RDialog);
 RegisterType(RButton);
 RegisterType(RInputLine);
 RegisterType(RScrollBar);
 RegisterType(RListBox);
 RegisterType(RStaticText);
 RegisterType(RPicture);
 RegisterType(RCheckBox);
 RegisterType(RRadioButtons);
 RegisterType(RPictoGram);
 REgisterType(RViewLine);
 RegisterType(RLabel);
 RegisterType(RBorder);
 RegisterType(RGraphicText);
 RegisterType(RMultyBox);
end;
{$IFDEF Ver55}
begin
With  RDialog do
 begin
  VmtLink:=ofs(TypeOf(TDialog)^);
  Load:=@TDialog.Load;
  Store:=@TDialog.Store;
  Next:=0;
 end;
With  RPictogram do
 begin
  VmtLink:=ofs(TypeOf(TPictogram)^);
  Load:=@TPictogram.Load;
  Store:=@TPictogram.Store;
  Next:=0;
 end;
With  RPicture do
 begin
  VmtLink:=ofs(TypeOf(TPicture)^);
  Load:=@TPicture.Load;
  Store:=@TPicture.Store;
  Next:=0;
 end;
With  RStaticText do
 begin
  VmtLink:=ofs(TypeOf(TStaticText)^);
  Load:=@TStaticText.Load;
  Store:=@TStaticText.Store;
  Next:=0;
 end;
With  RInputLine do
 begin
  VmtLink:=ofs(TypeOf(TInputLine)^);
  Load:=@TInputLine.Load;
  Store:=@TInputLine.Store;
  Next:=0;
 end;
With  RScrollBar do
 begin
  VmtLink:=ofs(TypeOf(TScrollBar)^);
  Load:=@TScrollBar.Load;
  Store:=@TScrollBar.Store;
  Next:=0;
 end;
With  RListBox do
 begin
  VmtLink:=ofs(TypeOf(TListBox)^);
  Load:=@TListBox.Load;
  Store:=@TListBox.Store;
  Next:=0;
 end;
With  RCheckBox do
 begin
  VmtLink:=ofs(TypeOf(TCheckBox)^);
  Load:=@TCheckBox.Load;
  Store:=@TCheckBox.Store;
  Next:=0;
 end;
With  RRadioButtons do
 begin
  VmtLink:=ofs(TypeOf(TRadioButtons)^);
  Load:=@TRadioButtons.Load;
  Store:=@TRadioButtons.Store;
  Next:=0;
 end;
With  RBorder do
 begin
  VmtLink:=ofs(TypeOf(TBorder)^);
  Load:=@TBorder.Load;
  Store:=@TBorder.Store;
  Next:=0;
 end;
With  RLabel do
 begin
  VmtLink:=ofs(TypeOf(TLabel)^);
  Load:=@TLabel.Load;
  Store:=@TLabel.Store;
  Next:=0;
 end;
With  RViewLine do
 begin
  VmtLink:=ofs(TypeOf(TViewLine)^);
  Load:=@TViewLine.Load;
  Store:=@TViewLine.Store;
  Next:=0;
 end;
With  RButton do
 begin
  VmtLink:=ofs(TypeOf(TButton)^);
  Load:=@TButton.Load;
  Store:=@TButton.Store;
  Next:=0;
 end;
{$ENDIF}
end.